//
// KeychainEnumsTests.swift
//
// Created by Andriy Slyusar on 2019-09-14.
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//

import XCTest
import Nimble
import Quick
@testable import SwiftyKeychainKit


class KeychainEnumsSpec: QuickSpec {
    override func spec() {
        describe("Item Class enum") {
            it("it has correct raw values") {
                expect(ItemClass.genericPassword.rawValue) == kSecClassGenericPassword
                expect(ItemClass.internetPassword.rawValue) == kSecClassInternetPassword
            }
        }

        describe("AccessibilityLevel enum") {
            it("it has correct raw values") {
                expect(AccessibilityLevel.whenPasscodeSetThisDeviceOnly.rawValue) == kSecAttrAccessibleWhenPasscodeSetThisDeviceOnly
                expect(AccessibilityLevel.whenPasscodeSetThisDeviceOnly.rawValue) == kSecAttrAccessibleWhenPasscodeSetThisDeviceOnly
                expect(AccessibilityLevel.unlockedThisDeviceOnly.rawValue) == kSecAttrAccessibleWhenUnlockedThisDeviceOnly
                expect(AccessibilityLevel.whenUnlocked.rawValue) == kSecAttrAccessibleWhenUnlocked
                expect(AccessibilityLevel.afterFirstUnlockThisDeviceOnly.rawValue) == kSecAttrAccessibleAfterFirstUnlockThisDeviceOnly
                expect(AccessibilityLevel.afterFirstUnlock.rawValue) == kSecAttrAccessibleAfterFirstUnlock
                expect(AccessibilityLevel.alwaysThisDeviceOnly.rawValue) == kSecAttrAccessibleAlwaysThisDeviceOnly
                expect(AccessibilityLevel.accessibleAlways.rawValue) == kSecAttrAccessibleAlways
            }
        }
    }
}
